;#########################################################################################
; ExtraSpy - Sparring Dialog  (v.2008-10-01)  //  experimental draft
;#########################################################################################

.386
.model flat,stdcall
option casemap:none

; ml   /I\masm32\include ...
; link /libpath:\masm32\lib ...

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32

; [proc]
; htodw
; GetDlgItemData
; SetDlgItemData
; TestSetDlgItemText
; StyleSwitch
; StyleMon
; OrWS
; CountUserGdiObjects
; DescendantWindowFromPoint
; MultilineEdit
; Details
; ExtraSub
; PrePropEnumProcEx
; PropEnumProcEx
; ShowInfo
; OnTimer
; ClassInfo
; RegisterWndClass
; ProcSwitch
; HTTransparentControl
; NewCombol
; OnClose
; CopyComboContent
; CopyControl
; ReadTemplate
; CreateDlgWindow
; RestoreMsgBox
; NewMsgBox
; CBTProc
; EnThWnd
; MsgBox
; OnMouseWheel
; OnCommand
; OnSetCursor
; OnInitDialog
    DlgProc proto :DWORD,:DWORD,:DWORD,:DWORD
    WndProc proto :DWORD,:DWORD,:DWORD,:DWORD
; ActiveDialogMessageLoop
; ThreadProc

GUITHREADINFO struct
  cbSize         DWORD ?
  flags          DWORD ?
  hwndActive     HWND  ?
  hwndFocus      HWND  ?
  hwndCapture    HWND  ?
  hwndMenuOwner  HWND  ?
  hwndMoveSize   HWND  ?
  hwndCaret      HWND  ?
  rcCaret        RECT <>
GUITHREADINFO ends

.const
  DC_HASDEFID_M equ 534Bh  ; !! ERROR in MASM32: "DC_HASDEFID equ 534h"
  id            equ 100
  max           equ 5
  toptextout    equ 20
  
.data
  _app          db " ExtraSpy   -   Sparring  Dialog  by  kero      //      %s    (%d)",0
  _about        db "<geocities.com/xmemor>",0
  _ver          db "2008-10-01",0
  _wnd          db "WndCls",0          
  _dlg          db "#32770",0
  _msgbox       db "MsgBox",0
  _dlgbox       db "DlgBox",0
  _createdlg    db "CreateDlg",0
  _createwnd    db "CreateWnd",0
  _hook         db " Hooked "
  _msgb         db " Message  Box    (%d)",0
  _mbfact       db "To  know  whether  the  window  is  the  message  box:",13,10
                db "activate  the  window ,  Ctrl+C / Ctrl+Ins  and  look  on  clipboard.",0
  _msg          db "msgresult",0
  _dlgp         db "dlgproc",0
  _user         db "user",0
  _unav         db "-",0 ; (unavailable)
  _sp           db "    ",0
  _user32       db "user32",0
  _wfp_0        db "WindowFromPoint",0
  _wfp_1        db "MapWindowPoints + RealChildWindowFromPoint    // unless  WS_EX_LAYOUTRTL",0  
  _wfp_2        db "MapWindowPoints + ChildWindowFromPointEx /all",0
  _wfp_3        db "MapWindowPoints + ChildWindowFromPointEx /skip:  invisible",0
  _wfp_4        db "MapWindowPoints + ChildWindowFromPointEx /skip:  invisible  transparent",0
  _wfp_5        db "MapWindowPoints + ChildWindowFromPointEx /skip:  invisible  disabled",0  
  _getguiresources    db "GetGuiResources",0
  _messageboxtimeouta db "MessageBoxTimeoutA",0
  _c_1          db "CS_VREDRAW",0
  _c_2          db "CS_HREDRAW",0
  _c_4          db "CS_KEYCVTWINDOW",0
  _c_8          db "CS_DBLCLKS",0
  _c_10         db "10_",0
  _c_20         db "CS_OWNDC",0
  _c_40         db "CS_CLASSDC",0
  _c_80         db "CS_PARENTDC",0
  _c_100        db "CS_NOKEYCVT",0
  _c_200        db "CS_NOCLOSE",0
  _c_400        db "400_",0
  _c_800        db "CS_SAVEBITS",0
  _c_1000       db "CS_BYTEALIGNCLIENT",0
  _c_2000       db "CS_BYTEALIGNWINDOW",0
  _c_4000       db "CS_GLOBALCLASS",0
  _c_8000       db "8000_",0
  _c_10000      db "CS_IME",0
  _c_20000      db "CS_DROPSHADOW",0  
  _d_1          db "DS_ABSALIGN_WS_ACTIVECAPTION",0
  _d_2          db "DS_SYSMODAL",0
  _d_4          db "DS_3DLOOK",0
  _d_8          db "DS_FIXEDSYS",0
  _d_10         db "DS_NOFAILCREATE",0
  _d_20         db "DS_LOCALEDIT",0
  _d_40         db "DS_SETFONT",0
  _d_80         db "DS_MODALFRAME",0
  _d_100        db "DS_NOIDLEMSG",0
  _d_200        db "DS_SETFOREGROUND",0
  _d_400        db "DS_CONTROL",0
  _d_800        db "DS_CENTER",0
  _d_1000       db "DS_CENTERMOUSE",0
  _d_2000       db "DS_CONTEXTHELP",0
  _d_48         db "DS_SHELLFONT",0 ; (=DS_SETFONT|DS_FIXEDSYS)
;  _w_0          db "WS_OVERLAPPED",0
;  _w_C00000     db "WS_CAPTION",0  
;  _w_1          db "WS_ACTIVECAPTION",0 ; (=DS_ABSALIGN)
  _w_10000      db "WS_MAXIMIZEBOX_TABSTOP",0
  _w_20000      db "WS_MINIMIZEBOX_GROUP",0
  _w_40000      db "WS_THICKFRAME",0
  _w_80000      db "WS_SYSMENU",0
  _w_100000     db "WS_HSCROLL",0
  _w_200000     db "WS_VSCROLL",0
  _w_400000     db "WS_DLGFRAME",0
  _w_800000     db "WS_BORDER",0
  _w_1000000    db "WS_MAXIMIZE",0
  _w_2000000    db "WS_CLIPCHILDREN",0
  _w_4000000    db "WS_CLIPSIBLINGS",0
  _w_8000000    db "WS_DISABLED",0
  _w_10000000   db "WS_VISIBLE",0
  _w_20000000   db "WS_MINIMIZE",0
  _w_40000000   db "WS_CHILD",0
  _w_80000000   db "WS_POPUP",0
;  _x_0          db "WS_EX_LEFT",0
;  _x_0          db "WS_EX_LTRREADING",0
;  _x_0          db "WS_EX_RIGHTSCROLLBAR",0
  _x_1          db "WS_EX_DLGMODALFRAME",0
  _x_2          db "2_",0
  _x_4          db "WS_EX_NOPARENTNOTIFY",0
  _x_8          db "WS_EX_TOPMOST",0
  _x_10         db "WS_EX_ACCEPTFILES",0
  _x_20         db "WS_EX_TRANSPARENT",0
  _x_40         db "WS_EX_MDICHILD",0
  _x_80         db "WS_EX_TOOLWINDOW",0
  _x_100        db "WS_EX_WINDOWEDGE",0
  _x_200        db "WS_EX_CLIENTEDGE",0
  _x_400        db "WS_EX_CONTEXTHELP",0
  _x_800        db "800_",0
  _x_1000       db "WS_EX_RIGHT",0
  _x_2000       db "WS_EX_RTLREADING",0      
  _x_4000       db "WS_EX_LEFTSCROLLBAR",0
  _x_8000       db "8000_",0
  _x_10000      db "WS_EX_CONTROLPARENT",0
  _x_20000      db "WS_EX_STATICEDGE",0
  _x_40000      db "WS_EX_APPWINDOW",0
  _x_80000      db "WS_EX_LAYERED",0
  _x_100000     db "WS_EX_NOINHERITLAYOUT",0
  _x_200000     db "200000_",0
  _x_400000     db "WS_EX_LAYOUTRTL",0
  _x_800000     db "800000_",0
  _x_1000000    db "1000000_",0
  _x_2000000    db "WS_EX_COMPOSITED",0
  _x_4000000    db "4000000_",0
  _x_8000000    db "WS_EX_NOACTIVATE",0
;  _x_300        db "WS_EX_OVERLAPPEDWINDOW equ (WS_EX_WINDOWEDGE Or WS_EX_CLIENTEDGE)",0
;  _x_188        db "WS_EX_PALETTEWINDOW equ (WS_EX_WINDOWEDGE Or WS_EX_TOOLWINDOW Or WS_EX_TOPMOST)",0
  _dlgc_1       db "DLGC_WANTARROWS",0
  _dlgc_2       db "DLGC_WANTTAB",0
  _dlgc_4       db "DLGC_WANTALLKEYS_WANTMESSAGE",0
  _dlgc_8       db "DLGC_HASSETSEL",0
  _dlgc_10      db "DLGC_DEFPUSHBUTTON",0
  _dlgc_20      db "DLGC_UNDEFPUSHBUTTON",0
  _dlgc_40      db "DLGC_RADIOBUTTON",0
  _dlgc_80      db "DLGC_WANTCHARS",0
  _dlgc_100     db "DLGC_STATIC",0
  _dlgc_200     db "200_",0
  _dlgc_400     db "400_",0
  _dlgc_800     db "800_",0
  _dlgc_1000    db "1000_",0
  _dlgc_2000    db "DLGC_BUTTON",0
  _msgf_0       db "0=MSGF_DIALOGBOX",0
  _msgf_1       db "1=MSGF_MESSAGEBOX",0
  _msgf_2       db "2=MSGF_MENU",0
  _msgf_3       db "3=MSGF_MOVE",0
  _msgf_4       db "4=MSGF_SIZE",0
  _msgf_5       db "5=MSGF_SCROLLBAR",0
  _msgf_6       db "6=MSGF_NEXTWINDOW",0
  _msgf_8       db "8=MSGF_MAINLOOP",0
  _msgf_q       db "?=MSGF_?",0
  _idle         db " WM_ENTERIDLE:  wParam=%s,  lParam=%8.8lX=hw",0
  _noidle       db "ds_noidlemsg  %X  %X",0
  _msgloop      db " msgloop: %lu ",0
  _msgdlg       db " dlg: %lu ",0
  _msgwnd       db " wnd: %lu ",0
  _ugo          db " user: %d   gdi: %d    tid: %lu (%lu)   %lu   ",0
  _hk           db " HCBT_CREATEWND  owner / parent :   %lX / %8.8lX  ",0
  _ht           db "    HT: %d / %d",0
  _hwnd         db "hwnd.%lu",0
  _hwndvia      db "hwnd.%lu:  via  %s",0
  _d            db "%2.2d",0
  _lX           db "%8.8lX",0
  _X            db "%lX",0
  _dlXs         db "%2.2d   "
  _lXs          db "%8.8lX   "
  _s            db "%s",0
  _ssx          db "%s  %s  (%4.4lX)",0
  _lu           db "%lu"
  _z            db 0
  lf            LOGFONT <-11,0,0,0,400,0,0,0,1,0,0,0,0,"Tahoma">
;
; [experiment: intensive using control's USERDATA memory] << G/SetWindowLong((GetDlgItem(hWnd,ID),GWL_USERDATA)>>
;  ID=id+1:     WndMsgCount
;  ID=id+2:     DlgMsgCount
;  ID=id+3:     fixed hw
;  ID=id+4:     WM_GETDLGCODE result
;  ID=id+5:     window spy via:
;   0:           WindowFromPoint
;   1:           RealChildWindowFromPoint
;   2:           ChildWindowFromPointEx /CWP_ALL
;   3:           ChildWindowFromPointEx /CWP_SKIPINVISIBLE
;   4:           ChildWindowFromPointEx /CWP_SKIPINVISIBLE|CWP_SKIPTRANSPARENT
;   5:           ChildWindowFromPointEx /CWP_SKIPINVISIBLE|CWP_SKIPDISABLED
;  ID=id+7:     old current hw
;  ID=id+8:     smflag (Details - SymbolicNumeric)
;  ID=id+(9,10,11,12):      combobox oldproc
;  ID=id+(9,10,11,12)/1000: combolbox oldproc
;  ID=id+15:    mbdlg switch
;  ID=id+16:    mbwnd switch
;  ID=id+19:    hWnd msgflag
;  ID=id+20:    multiline edit oldproc
;  ID=id+25:    Details switch (0...max)
;  ID=id+27:    WM_ENTERIDLE /wParam, count
;  ID=id+30:    WM_ENTERIDLE /lParam
;  ID=id+31:    dlg/wnd type (1...8)
;   1:           DlgBox    non-owned
;   2:           DlgBox    owned
;   3:           CreateDlg non-owned
;   4:           CreateDlg owned
;   5:           CreateWnd non-owned
;   6:           CreateWnd owned
;   7:           MsgBox    non-owned hooked
;   8:           MsgBox    owned     hooked
;  ID=id+43:    oldwndproc
;  ID=id+44:    olddlgproc
;  ID=id+47:    combo item count

.data?
  hinst         dd ?
  hdc           dd ?
  hfont         dd ?
  lptmpl        dd ?  ; (pointer to dlgtemplate)  
  nowned        dd ?  ; (number of created non-owned dlg/wnd)
  counter       dd ?  ;   
  hhook         dd ?  ; (for MessageBox)
  hookflag      dd ?  ; (for MessageBox)
  mbowner       dd ?  ; (for MessageBox)
  oldmbwndproc  dd ?  ; (for MessageBox)
  oldmbdlgproc  dd ?  ; (for MessageBox)
  tid1          dd ?  ; (1st thread id)
  tid2          dd ?  ; (2nd thread id)
  noIdle        dd ?  ; (state of "ds_noidlemsg" checkbox)
  cpos          dd ?  ; (pos by DS_CENTER)
  msgflag       dd ?  ; (loop/dlgproc/wndproc msgcount)

.code

;#########################################################################################
; (From: masm32\m32lib\htodw.asm)

htodw proc String:DWORD
  ; -----------------------------------
  ; Convert hex string into dword value
  ; Return value in eax
  ; -----------------------------------
    push ebx
    push esi
    push edi
    mov edi, String
    mov esi, String 
     ALIGN 4
  again:  
    mov al,[edi]
    inc edi
    or  al,al
    jnz again
    sub esi,edi
    xor ebx,ebx
    add edi,esi
    xor edx,edx
    not esi             ;esi = lenth
  .while esi != 0
    mov al, [edi]
    cmp al,'A'
    jb figure
    sub al,'a'-10
    adc dl,0
    shl dl,5            ;if cf set we get it bl 20h else - 0
    add al,dl
    jmp next
  figure: 
    sub al,'0'
  next:  
    lea ecx,[esi-1]
    and eax, 0Fh
    shl ecx,2           ;mul ecx by log 16(2)
    shl eax,cl          ;eax * 2^ecx
    add ebx, eax
    inc edi
    dec esi
  .endw
    mov eax,ebx
    pop edi
    pop esi
    pop ebx
    ret
htodw endp

;#########################################################################################

GetDlgItemData proc hWnd:HWND,Id:DWORD
  invoke GetDlgItem,hWnd,Id
  push eax
  invoke GetWindowLong,eax,GWL_USERDATA
  pop edx
  ret
GetDlgItemData endp

;#########################################################################################

SetDlgItemData proc hWnd:HWND,Id:DWORD,data:DWORD
  invoke GetDlgItem,hWnd,Id
  push eax
  invoke SetWindowLong,eax,GWL_USERDATA,data
  pop edx
  ret
SetDlgItemData endp

;#########################################################################################

TestSetDlgItemText proc hWnd:HWND,Id:DWORD,lpbuf:LPSTR

  local buf[512]:BYTE
  
  invoke GetDlgItemText,hWnd,Id,addr buf,127
  invoke lstrcmp,addr buf,lpbuf
  push eax
  .if eax!=0
    invoke SetDlgItemText,hWnd,Id,lpbuf
  .endif
  pop eax
  ret
TestSetDlgItemText endp

;#########################################################################################

StyleSwitch proc uses ebx hWnd:HWND,param:DWORD,style:DWORD,flg:DWORD

  invoke GetDlgItemData,hWnd,id+3
  mov ebx,eax
  invoke GetWindowLong,ebx,param
  mov ecx,style
  .if flg!=0
    or eax,ecx
  .else
    not ecx
    and eax,ecx
  .endif
  invoke SetWindowLong,ebx,param,eax
  invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
  ret
StyleSwitch endp

;#########################################################################################

StyleMon proc uses ebx hWnd:HWND,sumstyle:DWORD,style:DWORD,cid:DWORD

  mov eax,sumstyle
  and eax,style
  mov ebx,eax
  .if ebx!=0
    mov ebx,BST_CHECKED
  .endif      
  invoke IsDlgButtonChecked,hWnd,cid
  .if (eax!=0 && ebx==0) || (eax==0 && ebx!=0)
    invoke CheckDlgButton,hWnd,cid,ebx
  .endif
  ret
StyleMon endp

;#########################################################################################

OrWS proc hWnd:HWND,param:DWORD,style:DWORD

  invoke GetWindowLong,hWnd,param
  or eax,style
  invoke SetWindowLong,hWnd,param,eax
  invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
  ret
OrWS endp

;#########################################################################################

CountUserGdiObjects proc uses ebx edi  ; (WinOS >= 2k_pro)

  invoke GetModuleHandle,offset _user32
  invoke GetProcAddress,eax,offset _getguiresources
  xor edx,edx
  test eax,eax
  jz @f
  mov ebx,eax
  call GetCurrentProcessId
  invoke OpenProcess,PROCESS_QUERY_INFORMATION,FALSE,eax
  test eax,eax
  jz @f
  push eax
  push GR_GDIOBJECTS
  push eax
  push GR_USEROBJECTS
  push eax
  call ebx
  mov edi,eax
  call ebx
  mov ebx,eax
  call CloseHandle
  mov eax,edi
  mov edx,ebx
@@:
  ret
CountUserGdiObjects endp

;#########################################################################################

DescendantWindowFromPoint proc uses ebx edi hWnd:HWND,ptx:DWORD,pty:DWORD,param:DWORD

 local pt:POINT, rt:RECT
  
  invoke GetDlgItemData,param,id+5
  mov edi,eax
  mov eax,ptx
  mov pt.x,eax
  mov eax,pty
  mov pt.y,eax
  .if hWnd==0
    invoke GetDesktopWindow
    mov ebx,eax
  .else
    mov ebx,hWnd  
  .endif
  xor ecx,ecx
  .if edi==0
    invoke WindowFromPoint,ptx,pty
    mov ebx,eax
  .else
@lay:
    invoke MapWindowPoints,ecx,ebx,addr pt,1
    .if edi==1
;      invoke GetWindowLong,ebx,GWL_EXSTYLE
;      and eax,WS_EX_LAYOUTRTL
;      .if eax!=0
;        invoke GetClientRect,ebx,addr rt
;        mov eax,rt.right
;        sub eax,pt.x
;        mov pt.x,eax
;      .endif
      invoke RealChildWindowFromPoint,ebx,pt.x,pt.y
    .elseif edi==2
      mov eax,CWP_ALL ; 000h
      jmp @f
    .elseif edi==3
      mov eax,CWP_SKIPINVISIBLE ; 001h
      jmp @f
    .elseif edi==4
      mov eax,CWP_SKIPINVISIBLE or CWP_SKIPTRANSPARENT ; 101h
      jmp @f
    .elseif edi==5
      mov eax,CWP_SKIPINVISIBLE or CWP_SKIPDISABLED ; 011h
@@: 
      invoke ChildWindowFromPointEx,ebx,pt.x,pt.y,eax
    .endif
    .if eax!=0 && eax!=ebx
      mov ecx,ebx
      mov ebx,eax
      jmp @lay
    .endif
  .endif
  mov eax,ebx
  ret
DescendantWindowFromPoint endp

;#########################################################################################

MultilineEdit proc uses ebx edi esi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

  local buf[512]:BYTE
  
  .if uMsg==WM_NCHITTEST
    invoke GetAncestor,hWnd,GA_ROOT
    invoke GetDlgItemData,eax,id+8
    .if eax==0
;    .if smflag==0
      mov eax,HTTRANSPARENT
      jmp @ret
    .endif
  .endif
  invoke GetWindowLong,hWnd,GWL_USERDATA
  invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
  .if uMsg==WM_LBUTTONDBLCLK
    invoke SendMessage,hWnd,WM_GETTEXT,511,addr buf
    invoke SendMessage,hWnd,EM_GETSEL,0,0
    shr eax,16
    xor edi,edi
    xor ebx,ebx
    lea edx,buf
@1:
    mov cl,byte ptr[edx+edi]
    dec eax
    inc edi
    .if eax==0
      jmp @3
    .elseif cl!=' '
      jmp @1
    .endif
    inc ebx
@2:
    mov cl,byte ptr[edx+edi]
    dec eax
    inc edi
    .if eax==0
      jmp @3
    .elseif cl==' '
      jmp @2
    .endif
    jmp @1
@3:
    invoke GetAncestor,hWnd,GA_ROOT
    mov edi,eax
    invoke GetDlgItemData,edi,id+3
    mov esi,eax
    invoke IsDlgButtonChecked,edi,id+42
    push eax
    invoke IsDlgButtonChecked,edi,id+2
    push eax
    invoke GetDlgItemData,edi,id+25
    mov ecx,ebx
    .if eax==2
      add ecx,16
    .endif
    dec ecx
    xor ebx,ebx
    inc ebx
    shl ebx,cl
    pop ecx
    pop edx
    .if edx==0 && ecx!=0
      .if eax==1
        invoke GetWindowLong,esi,GWL_STYLE
        xor eax,ebx
        invoke SetWindowLong,esi,GWL_STYLE,eax
        invoke SetWindowPos,esi,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
      .elseif eax==2
        invoke GetWindowLong,esi,GWL_STYLE
        xor eax,ebx
        invoke SetWindowLong,esi,GWL_STYLE,eax
        invoke SetWindowPos,esi,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
      .elseif eax==3
        invoke GetWindowLong,esi,GWL_EXSTYLE
        xor eax,ebx
        invoke SetWindowLong,esi,GWL_EXSTYLE,eax
        invoke SetWindowPos,esi,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
      .elseif eax==0
        invoke GetClassLong,esi,GCL_STYLE
        xor eax,ebx
        invoke SetClassLong,esi,GCL_STYLE,eax
        invoke SetWindowPos,esi,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
      .endif
    .elseif edx!=0
      mov edx,lptmpl
      .if eax==1 || eax==2
        mov eax,12 ; ws_
        jmp @f
      .elseif eax==3
        mov eax,8 ; ws_ex_
@@:
        mov ecx,dword ptr[edx+eax]
        xor ecx,ebx
        mov dword ptr[edx+eax],ecx
      .endif
    .endif
  .endif
@ret:
  ret
MultilineEdit endp

;#########################################################################################

Details proc uses ebx edi esi hWnd:HWND,lParam:LPARAM

  local buf[512]:BYTE, buf2[512]:BYTE

  .if lParam==7  ; hwnd via...
    invoke GetDlgItemData,hWnd,id+5
    .if eax==0
      mov ecx,offset _wfp_0
    .elseif eax==1
      mov ecx,offset _wfp_1
    .elseif eax==2
      mov ecx,offset _wfp_2
    .elseif eax==3
      mov ecx,offset _wfp_3
    .elseif eax==4
      mov ecx,offset _wfp_4
    .elseif eax==5
      mov ecx,offset _wfp_5
    .endif
    invoke wsprintf,addr buf,offset _hwndvia,eax,ecx
    jmp @@@
  .elseif lParam==6  ; wm_enteridle
    invoke GetDlgItemData,hWnd,id+30
    mov ebx,eax
    invoke GetDlgItemData,hWnd,id+27
    .if ah==0
      mov ecx,offset _msgf_0
    .elseif ah==1
      mov ecx,offset _msgf_1
    .elseif ah==2
      mov ecx,offset _msgf_2
    .elseif ah==3
      mov ecx,offset _msgf_3
    .elseif ah==4
      mov ecx,offset _msgf_4
    .elseif ah==5
      mov ecx,offset _msgf_5
    .elseif ah==6
      mov ecx,offset _msgf_6
    .elseif ah==8
      mov ecx,offset _msgf_8
    .else
      mov ecx,offset _msgf_q
    .endif
    invoke wsprintf,addr buf,offset _idle,ecx,ebx
    jmp @@@    
  .elseif lParam==5  ; error codes
    invoke GetDlgItemInt,hWnd,id+25,0,0
    mov ecx,eax
    invoke FormatMessage,FORMAT_MESSAGE_FROM_SYSTEM,0,ecx,0,addr buf,511,0 ; 1000h
    jmp @@@
  .elseif lParam==4  ; dlgc_
    push offset _dlgc_2000
    push offset _dlgc_1000
    push offset _dlgc_800
    push offset _dlgc_400
    push offset _dlgc_200
    push offset _dlgc_100
    push offset _dlgc_80
    push offset _dlgc_40
    push offset _dlgc_20
    push offset _dlgc_10
    push offset _dlgc_8
    push offset _dlgc_4
    push offset _dlgc_2
    push offset _dlgc_1
    mov edi,1
    mov esi,2000h
    invoke GetDlgItemData,hWnd,id+4
  .elseif lParam==1  ; ds_
    push offset _d_48
    push offset _d_2000
    push offset _d_1000
    push offset _d_800
    push offset _d_400
    push offset _d_200
    push offset _d_100
    push offset _d_80
    push offset _d_40
    push offset _d_20
    push offset _d_10
    push offset _d_8
    push offset _d_4
    push offset _d_2
    push offset _d_1
    mov edi,1
    mov esi,4000h
    mov ecx,id+36
    jmp @f
  .elseif lParam==2  ; ws_
    push offset _w_80000000
    push offset _w_40000000
    push offset _w_20000000
    push offset _w_10000000
    push offset _w_8000000
    push offset _w_4000000
    push offset _w_2000000
    push offset _w_1000000
    push offset _w_800000
    push offset _w_400000
    push offset _w_200000
    push offset _w_100000
    push offset _w_80000
    push offset _w_40000
    push offset _w_20000
    push offset _w_10000
    mov edi,10000h
    mov esi,80000000h
    mov ecx,id+37
    jmp @f    
  .elseif lParam==3  ; ws_ex_
    push offset _x_8000000
    push offset _x_4000000
    push offset _x_2000000
    push offset _x_1000000
    push offset _x_800000
    push offset _x_400000
    push offset _x_200000
    push offset _x_100000
    push offset _x_80000
    push offset _x_40000
    push offset _x_20000
    push offset _x_10000
    push offset _x_8000
    push offset _x_4000
    push offset _x_2000
    push offset _x_1000
    push offset _x_800
    push offset _x_400
    push offset _x_200
    push offset _x_100
    push offset _x_80
    push offset _x_40
    push offset _x_20
    push offset _x_10
    push offset _x_8
    push offset _x_4
    push offset _x_2
    push offset _x_1
    mov edi,1
    mov esi,8000000h
    mov ecx,id+38
    jmp @f
  .else  ; cs_
    push offset _c_20000
    push offset _c_10000
    push offset _c_8000
    push offset _c_4000
    push offset _c_2000
    push offset _c_1000
    push offset _c_800
    push offset _c_400
    push offset _c_200
    push offset _c_100
    push offset _c_80
    push offset _c_40
    push offset _c_20
    push offset _c_10
    push offset _c_8
    push offset _c_4
    push offset _c_2
    push offset _c_1
    mov edi,1
    mov esi,20000h
    mov ecx,id+13
@@:
    invoke GetDlgItemText,hWnd,ecx,addr buf,9
    invoke htodw,addr buf    
  .endif
  mov ebx,eax
  mov byte ptr [buf],0
  .while edi>0 && edi<=esi
    pop ecx
    .if edi==4000h && lParam==1
      mov edx,DS_SHELLFONT ; (48h)
;;;
      mov eax,ebx
      and eax,edx
      .if eax!=edx
        jmp @f
      .endif
    .else
      mov edx,edi
      and edx,ebx
      .if edx==0
        invoke GetDlgItemData,hWnd,id+8
        .if eax!=0
;        .if smflag!=0
          invoke wsprintf,addr buf2,offset _X,edi
          lea ecx,buf2
        .else
          jmp @f
        .endif
      .endif
    .endif
    invoke lstrcat,addr buf,ecx
    invoke lstrcat,addr buf,offset _sp
@@:
    shl edi,1
  .endw
@@@:
  invoke TestSetDlgItemText,hWnd,id+20,addr buf
  ret
Details endp

;#########################################################################################

ExtraSub proc uses ebx edi esi hWnd:HWND,hW:HWND,iD:DWORD,param:DWORD

  local buf[128]:BYTE, buf2[256]:BYTE, var:DWORD

  invoke GetDlgItemData,hWnd,id+7
  .if eax!=hW
    invoke SendDlgItemMessage,hWnd,id+9,CB_RESETCONTENT,0,0
    invoke SendDlgItemMessage,hWnd,id+10,CB_RESETCONTENT,0,0
    invoke SetDlgItemData,hWnd,id+7,hW
  .elseif param!=0
    invoke SendDlgItemMessage,hWnd,iD,CB_RESETCONTENT,0,0  
  .endif

  .if iD==id+10
    mov eax,GCL_CBWNDEXTRA
  .else
    mov iD,id+9
    mov eax,GCL_CBCLSEXTRA
  .endif
  invoke GetClassLong,hW,eax
  mov ebx,eax

  invoke IsDlgButtonChecked,hWnd,id+7
  .if eax!=0 && iD==id+10
    mov ebx,100
  .endif

  invoke SendDlgItemMessage,hWnd,iD,CB_GETCOUNT,0,0
  mov ecx,ebx
  shr ecx,2
  cmp ecx,eax
  jnz @f
  xor edi,edi

  .while edi<ebx
    .if iD==id+10
      invoke GetWindowLong,hW,edi
    .else
      invoke GetClassLong,hW,edi
    .endif
    push eax
    mov ecx,edi
    shr ecx,2
    invoke SendDlgItemMessage,hWnd,iD,CB_GETITEMDATA,ecx,0
    pop ecx
    cmp eax,ecx
    jnz @f
    add edi,4
  .endw

  jmp @@@
@@:
  xor edi,edi
  mov var,edi

  .while edi<ebx
@add: 
    .if iD==id+10
      invoke GetClassLong,hW,GCL_CBWNDEXTRA
      mov esi,eax
      invoke GetWindowLong,hW,edi
      mov ecx,offset _z
      .if esi>=30 && esi<72
       .if edi==0
         mov ecx,offset _msg
       .elseif edi==4
         mov ecx,offset _dlgp
       .elseif edi==8
         mov ecx,offset _user
       .elseif edi>=12 && edi<=28
         mov ecx,offset _unav
       .endif
     .endif
    .else  ; (iD==id+9)
      invoke GetClassLong,hW,edi
      mov ecx,offset _z
    .endif
    mov esi,eax

    invoke wsprintf,addr buf,offset _dlXs,edi,eax,ecx
    .if var!=-1
      invoke SendDlgItemMessage,hWnd,iD,CB_GETLBTEXT,var,addr buf2
      invoke lstrcmp,addr buf,addr buf2
      .if eax!=0
        invoke SendDlgItemMessage,hWnd,iD,CB_RESETCONTENT,0,0
        xor edi,edi
        mov var,-1
        jmp @add
      .endif
      inc var
    .else
      invoke SendDlgItemMessage,hWnd,iD,CB_ADDSTRING,0,addr buf
      invoke SendDlgItemMessage,hWnd,iD,CB_GETCOUNT,0,0
      dec eax
      invoke SendDlgItemMessage,hWnd,iD,CB_SETITEMDATA,eax,esi
    .endif
    add edi,4
  .endw
  .if var!=-1
    jmp @ret
  .else
    jmp @@@
  .endif
@@@:
  invoke SetDlgItemInt,hWnd,iD,ebx,0
@ret:
  ret
ExtraSub endp

;#########################################################################################

PrePropEnumProcEx proc uses ebx hWnd:HWND,lpszString:DWORD,hData:DWORD,dwData:DWORD

  local buf1[128]:BYTE, buf2[256]:BYTE
  
  invoke GetDlgItemData,dwData,id+47
  mov ebx,eax  
  xor al,al
  mov byte ptr [buf1],al
  mov byte ptr [buf2],al
  invoke lstrcpy,addr buf1,lpszString
  invoke wsprintf,addr buf2,offset _lXs,hData,addr buf1
  invoke SendDlgItemMessage,dwData,id+11,CB_GETLBTEXT,ebx,addr buf1
  invoke lstrcmp,addr buf1,addr buf2
  .if eax!=0
    xor ebx,ebx
  .else
    inc ebx
  .endif
  invoke SetDlgItemData,dwData,id+47,ebx
  mov eax,ebx
  ret
PrePropEnumProcEx endp

;#########################################################################################

PropEnumProcEx proc hWnd:HWND,lpszString:DWORD,hData:DWORD,dwData:DWORD

  local buf1[128]:BYTE, buf2[256]:BYTE
  
  xor al,al
  mov byte ptr [buf1],al
  mov byte ptr [buf2],al
  invoke lstrcpy,addr buf1,lpszString
  invoke wsprintf,addr buf2,offset _lXs,hData,addr buf1
  invoke SendDlgItemMessage,dwData,id+11,CB_ADDSTRING,0,addr buf2
  xor eax,eax
  inc eax
  ret
PropEnumProcEx endp

;#########################################################################################

ShowInfo proc uses ebx edi hWnd:HWND,hW:HWND

  local bu[256]:BYTE, buf1[256]:BYTE, buf2[256]:BYTE, pt:POINT, msg:MSG

  xor eax,eax
  invoke SetDlgItemData,hWnd,id+47,eax
  invoke EnumPropsEx,hW,offset PrePropEnumProcEx,hWnd
  invoke GetDlgItemData,hWnd,id+47
  .if eax==0
    invoke SendDlgItemMessage,hWnd,id+11,CB_RESETCONTENT,0,0
    invoke EnumPropsEx,hW,offset PropEnumProcEx,hWnd
  .endif
  invoke ExtraSub,hWnd,hW,id+10,0
  invoke ExtraSub,hWnd,hW,id+9,0
  invoke SendMessage,hW,WM_GETDLGCODE,0,addr msg
  mov ebx,eax
  invoke GetClassName,hW,addr bu,63
  invoke RealGetWindowClass,hW,addr buf2+2,61
  invoke lstrcmp,addr bu,addr buf2+2
  .if eax==0
    mov byte ptr [buf2],0
  .else
    mov word ptr [buf2],' /'
  .endif
  invoke wsprintf,addr buf1,offset _ssx,addr bu,addr buf2,ebx
  invoke TestSetDlgItemText,hWnd,id+4,addr buf1
  .if eax!=0
    invoke SetDlgItemData,hWnd,id+4,ebx
  .endif
  invoke wsprintf,addr bu,offset _lX,hW
  invoke TestSetDlgItemText,hWnd,id+3,addr bu
  invoke SendMessageTimeout,hW,WM_GETTEXT,255,addr buf1,SMTO_ABORTIFHUNG,300,0
  invoke TestSetDlgItemText,hWnd,id+34,addr buf1
  invoke GetCursorPos,addr pt
  mov eax,pt.x
  and eax,0ffffh
  mov edi,pt.y
  shl edi,16
  or edi,eax
  invoke DefWindowProc,hW,WM_NCHITTEST,0,edi
  push eax
  invoke SendMessageTimeout,hW,WM_NCHITTEST,0,edi,SMTO_ABORTIFHUNG,300,addr pt
  pop ecx
  invoke wsprintf,addr buf1,offset _ht,ecx,pt.x
  invoke TestSetDlgItemText,hWnd,id+48,addr buf1
  invoke IsDlgButtonChecked,hWnd,id+17
  .if eax!=0
    invoke SendMessageTimeout,hW,DM_GETDEFID,0,0,SMTO_ABORTIFHUNG,300,addr pt
    mov ecx,pt.x
    mov edx,ecx
    and ecx,0ffffh
    shr edx,16
    .if edx!=DC_HASDEFID_M
      mov word ptr[buf1],[0]['-']
    .else
      invoke wsprintf,addr buf1,offset _lu,ecx
    .endif
    invoke TestSetDlgItemText,hWnd,id+14,addr buf1
  .endif
  invoke IsDlgButtonChecked,hWnd,id+42
  mov ebx,eax
  mov edi,lptmpl
  .if ebx!=0
    mov eax,dword ptr[edi+12] ; ws_
  .else
    invoke GetWindowLong,hW,GWL_STYLE
  .endif
  mov ecx,eax  
  and ecx,00003FFFh
  push ecx
  push id+36 ; ds_
  push eax
  invoke StyleMon,hWnd,eax,DS_NOIDLEMSG,id+27  
  push id+37
  .if ebx!=0
    mov eax,dword ptr[edi+8] ; ws_ex_
  .else
    invoke GetWindowLong,hW,GWL_EXSTYLE
  .endif
  push eax
  invoke StyleMon,hWnd,eax,WS_EX_CONTROLPARENT,id+28
  push id+38
  .if ebx!=0
    invoke GetDlgItemText,hWnd,id+13,addr buf1,127
    invoke htodw,addr buf1
  .else
    invoke GetClassLong,hW,GCL_STYLE
  .endif
  push eax
  push id+13
  invoke GetClassLong,hW,GCL_WNDPROC
  push eax
  push id+43
  invoke GetWindowLong,hW,GWL_USERDATA
  push eax
  push id+16
  invoke GetWindowLong,hW,GWL_ID
  and eax,0ffffh
  push eax
  push id+15
  push nowned
  push id+47
  xor ebx,ebx
  .while ebx<8
    .if ebx==0 || ebx==1
      mov ecx,offset _lu
    .else
      mov ecx,offset _lX
    .endif
    pop edi
    pop eax
    invoke wsprintf,addr buf1,ecx,eax
    invoke TestSetDlgItemText,hWnd,edi,addr buf1
    inc ebx
  .endw
  invoke GetDlgItemData,hWnd,id+25
  invoke Details,hWnd,eax
  invoke IsWindowEnabled,hW
  mov ebx,eax
  invoke IsDlgButtonChecked,hWnd,id+30
  .if (ebx==0 && eax==0) || (ebx!=0 && eax!=0)
    invoke SendDlgItemMessage,hWnd,id+30,BM_CLICK,0,0
  .endif
  ret
ShowInfo endp

;#########################################################################################

OnTimer proc uses ebx hWnd:HWND

  local pt:POINT, guiti:GUITHREADINFO, buf[256]:BYTE
  
  invoke IsDlgButtonChecked,hWnd,id+1
  .if eax!=0
    invoke IsDlgButtonChecked,hWnd,id+2
    .if eax==0
      invoke GetCursorPos,addr pt
      invoke DescendantWindowFromPoint,0,pt.x,pt.y,hWnd
      mov ebx,eax
      invoke GetKeyState,VK_CONTROL                  ; CTRL :   hWnd / GA_ROOT, GW_OWNER, guiti.hwndMenuOwner
      and eax,8000h
      .if eax!=0
        invoke GetAncestor,ebx,GA_ROOT
        mov ebx,eax
        invoke GetWindow,ebx,GW_OWNER
        .if eax!=0
          mov ebx,eax
        .endif
        invoke GetWindowThreadProcessId,ebx,0
        mov ecx,eax
        mov guiti.cbSize,sizeof guiti
        invoke GetGUIThreadInfo,ecx,addr guiti
        mov ecx,guiti.hwndMenuOwner
        .if eax!=0 && ecx!=0
          mov ebx,ecx
        .endif
      .endif
      invoke GetKeyState,VK_F8                        ; F8 :   fix hwnd
      and eax,8000h
      .if eax!=0
        invoke CheckDlgButton,hWnd,id+2,BST_CHECKED      
        invoke SetDlgItemData,hWnd,id+3,ebx
      .endif
    .else
      invoke GetDlgItemData,hWnd,id+3
      mov ebx,eax
    .endif   
    invoke ShowInfo,hWnd,ebx
  .endif
  ret
OnTimer endp

;#########################################################################################
 
ClassInfo proc hWnd:HWND,lParam:LPARAM

  local buf[256]:BYTE, wc:WNDCLASSEX
  
  mov wc.cbSize,sizeof WNDCLASSEX  
  invoke SetDlgItemText,hWnd,id+13,0
  invoke SetDlgItemText,hWnd,id+9,0
  invoke SetDlgItemText,hWnd,id+10,0
  invoke GetDlgItemText,hWnd,id+12,addr buf,255
  mov ecx,lParam 
  .if ecx!=0
    mov ecx,hinst
  .endif
  invoke GetClassInfoEx,ecx,addr buf,addr wc
  .if eax==0
    invoke MessageBeep,0
  .else
    invoke wsprintf,addr buf,offset _lX,wc.style
    invoke SetDlgItemText,hWnd,id+13,addr buf
    invoke SetDlgItemInt,hWnd,id+9,wc.cbClsExtra,0
    invoke SetDlgItemInt,hWnd,id+10,wc.cbWndExtra,0
  .endif
  ret
ClassInfo endp

;#########################################################################################

RegisterWndClass proc hInst:HINSTANCE,lpwndproc:WNDPROC,lpwndclass:LPCTSTR,cbcls:DWORD,cbwnd:DWORD,style:DWORD

  local	wc:WNDCLASSEX
  
  mov	wc.cbSize,sizeof WNDCLASSEX
  invoke GetClassInfoEx,0,offset _dlg,addr wc
  mov	eax,hInst
  mov	wc.hInstance,eax
  mov eax,lpwndproc
  mov	wc.lpfnWndProc,eax
  mov eax,style
  mov wc.style,eax
  mov eax,cbcls
  mov wc.cbClsExtra,eax
  mov eax,cbwnd  
  mov wc.cbWndExtra,eax
  mov eax,lpwndclass
  mov	wc.lpszClassName,eax
  invoke SetLastError,0
  invoke RegisterClassEx,addr wc
  push eax
  invoke GetLastError
  mov edx,eax
  pop ecx
  and ecx,0ffffh
  mov eax,hInst
  ret
RegisterWndClass endp

;#########################################################################################

ProcSwitch proc uses ebx edi hWnd:HWND

  invoke GetWindowLong,hWnd,DWL_DLGPROC
  mov ebx,eax
  invoke GetDlgItemData,hWnd,id+15
  mov edi,eax
  invoke SetWindowLong,edx,GWL_USERDATA,ebx
  invoke SetWindowLong,hWnd,DWL_DLGPROC,edi
  invoke GetWindowLong,hWnd,GWL_WNDPROC
  mov ebx,eax
  invoke GetDlgItemData,hWnd,id+16
  mov edi,eax
  invoke SetWindowLong,edx,GWL_USERDATA,ebx
  invoke SetWindowLong,hWnd,GWL_WNDPROC,edi
  push eax
  .if eax==offset WndProc
    invoke KillTimer,hWnd,id
  .else  ; eax==offset NewMsgBox
    invoke SetTimer,hWnd,id,100,0
  .endif
  invoke InvalidateRect,hWnd,0,1
  pop eax
  ret
ProcSwitch endp

;#########################################################################################

HTTransparentControl proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  .if uMsg==WM_NCHITTEST
    mov eax,HTTRANSPARENT
  .else
    invoke GetWindowLong,hWnd,GWL_USERDATA
	  invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
	.endif
  ret
HTTransparentControl endp

;#########################################################################################

NewCombol proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  
  local buf[128]:BYTE, hwnd:HWND

	.if uMsg==WM_RBUTTONDOWN || uMsg==WM_LBUTTONDOWN
    invoke GetAncestor,hWnd,GA_PARENT
    invoke GetWindowLong,eax,GWL_ID
    and eax,0ffffh
    mov edi,eax
		invoke SendMessage,hWnd,LB_ITEMFROMPOINT,0,lParam
		mov esi,eax
	  invoke GetAncestor,hWnd,GA_ROOT
	  mov hwnd,eax
    invoke GetDlgItemData,eax,id+3
    mov ebx,eax
    invoke IsDlgButtonChecked,hwnd,id+2
    .if eax!=0 && uMsg==WM_RBUTTONDOWN && (edi==id+9 || edi==id+10)
		  shl esi,2
      invoke SetLastError,0
      push esi
      push ebx
      .if edi==id+9
        call GetClassLong
      .else
        call GetWindowLong
      .endif
      xor eax,1
      push eax
      push esi
      push ebx
      .if edi==id+9
        call SetClassLong
      .else
        call SetWindowLong
      .endif
      invoke GetLastError
      invoke SetDlgItemInt,hwnd,id+25,eax,0
    .elseif uMsg==WM_LBUTTONDOWN && edi==id+12
      invoke SendMessage,hWnd,LB_GETTEXT,esi,addr buf
      mov ebx,lptmpl
      add ebx,28  ; (unicode classname offset)
      lea edx,buf
      xor ecx,ecx
      .while ecx<=5
        mov al,byte ptr [edx+ecx]
        mov byte ptr [ebx+2*ecx],al
        inc ecx
      .endw
    .endif
	.endif
	invoke GetWindowLong,hWnd,GWL_USERDATA
	invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
	ret
NewCombol endp

;#########################################################################################

OnClose proc uses edi hWnd:HWND

  invoke GetDlgItemData,hWnd,id+19
  .if msgflag!=0 && eax!=0
    xor eax,eax
    mov msgflag,eax
    invoke InvalidateRect,0,0,1
  .endif
  invoke GetDlgItemData,hWnd,id+31
  mov edi,eax
  .if edi>=1 && edi<=8
    invoke KillTimer,hWnd,id    
    .if edi==1 || edi==3 || edi==5 || edi==7
      dec nowned
    .endif
    .if edi>=3 && edi<=6
      invoke DestroyWindow,hWnd
    .else
      invoke EndDialog,hWnd,0
    .endif
  .endif
  .if nowned==0
    invoke PostQuitMessage,0
  .endif
  ret
OnClose endp

;#########################################################################################

CopyComboContent proc uses ebx edi esi hWnd:HWND,lParam:LPARAM

  local buf[16]:BYTE

  mov ebx,lParam
  invoke GetDlgItem,hWnd,id+12
  .if ebx!=hWnd && eax!=0
    xor esi,esi
    invoke SendDlgItemMessage,ebx,id+12,CB_GETCOUNT,esi,esi
    mov edi,eax
    invoke SendDlgItemMessage,hWnd,id+12,CB_RESETCONTENT,esi,esi
    .while esi<edi
      invoke SendDlgItemMessage,ebx,id+12,CB_GETLBTEXT,esi,addr buf
      invoke SendDlgItemMessage,hWnd,id+12,CB_ADDSTRING,0,addr buf
      inc esi
    .endw
  .endif
  xor eax,eax
  inc eax
  ret
CopyComboContent endp

;#########################################################################################

CopyControl proc uses ebx edi esi hWnd:HWND, param:DWORD

  local rt:RECT, buf[64]:BYTE, buf2[256]:BYTE
  
  invoke GetAncestor,hWnd,GA_ROOT
  mov ebx,eax
  invoke GetAncestor,hWnd,GA_PARENT
  .if eax!=ebx
    jmp @f
  .endif
  invoke GetClassName,hWnd,addr buf,63
  invoke GetWindowText,hWnd,addr buf2,255
  invoke GetWindowLong,hWnd,GWL_EXSTYLE
  mov edi,eax
  invoke GetWindowLong,hWnd,GWL_STYLE
  mov esi,eax  
  invoke GetWindowRect,hWnd,addr rt
  invoke MapWindowPoints,0,ebx,addr rt,2
  invoke GetWindowLong,hWnd,GWL_ID
  mov edx,rt.left
  sub rt.right,edx
  mov ecx,rt.top
  sub rt.bottom,ecx
  invoke CreateWindowEx,edi,addr buf,addr buf2,esi,edx,ecx,rt.right,rt.bottom,param,eax,hinst,0
  mov edi,eax  
  invoke SendMessage,edi,WM_SETFONT,hfont,1
@@:
  mov eax,TRUE
  ret
CopyControl endp

;#########################################################################################

ReadTemplate proc uses ebx lpbuf:LPSTR

  mov ebx,lptmpl
  mov edx,lpbuf ; (unicode classname)
  xor ecx,ecx
  .while ecx<=5
    mov al,byte ptr [ebx+28+2*ecx]
    mov byte ptr [edx+ecx],al
    inc ecx
  .endw
  mov byte ptr[edx+ecx],0
  mov ecx,dword ptr[ebx+8]  ; (ws_ex)
  mov eax,dword ptr[ebx+12] ; (ws)
  ret
ReadTemplate endp

;#########################################################################################

CreateDlgWindow proc uses ebx edi hOwner:HWND,hWnd:HWND
  
  local buf[128]:BYTE
  
  invoke ReadTemplate,addr buf
  mov ebx,ecx
  mov edi,eax
;  and eax,DS_CENTER
;  .if eax!=0
; ...
;  .else
; ...
;  .endif
  invoke SetLastError,0
  invoke CreateWindowEx,ebx,addr buf,0,edi,0,0,0,0,hOwner,0,hinst,hWnd
  mov ebx,eax
  invoke GetLastError
  invoke SetDlgItemInt,hWnd,id+25,eax,0  
  invoke EnumChildWindows,hWnd,offset CopyControl,ebx  ; (instead of dlgitemtemplate reading)
  invoke SendMessage,hWnd,DM_GETDEFID,0,0
  mov edi,eax
  shr eax,16
  .if eax==DC_HASDEFID_M
    and edi,0ffffh
    invoke SendMessage,ebx,DM_SETDEFID,edi,0
  .endif
  invoke SetWindowLong,ebx,DWL_DLGPROC,offset DlgProc
  invoke SetDlgItemData,ebx,id+44,eax
  invoke SendMessage,ebx,WM_INITDIALOG,0,hWnd
  invoke InvalidateRect,ebx,0,1
  mov eax,ebx
  ret
CreateDlgWindow endp

;#########################################################################################

RestoreMsgBox proc hWnd:HWND,lParam:LPARAM

  invoke IsWindowVisible,hWnd
  .if eax!=0
;    invoke PostMessage,hWnd,WM_CLOSE,0,0
    invoke DestroyWindow,hWnd
  .else
    invoke ShowWindow,hWnd,SW_SHOWNORMAL
  .endif
  mov eax,TRUE
  ret
RestoreMsgBox endp

;#########################################################################################

NewMsgBox proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM  ;  (XP-pro-sp2: WM_TIMER => CLOSE MsgBox !)

  local pt:POINT, buf[128]:BYTE, rt:RECT
  
  .if uMsg==WM_APP+WM_CREATE
    dec counter
    invoke GetWindow,hWnd,GW_CHILD
    mov ebx,eax
    .while TRUE
      invoke GetWindow,ebx,GW_HWNDNEXT
      xchg eax,ebx
;;      invoke PostMessage,eax,WM_CLOSE,0,0
;      invoke DestroyWindow,hWnd
      invoke ShowWindow,eax,SW_HIDE
      .break .if !ebx
    .endw
    invoke GetWindowText,hWnd,addr buf,127
    invoke CreateWindowEx,0,offset _dlg,addr buf,WS_CHILD,0,0,0,0,hWnd,0,hinst,0
    mov ebx,eax
    invoke GetWindowLong,hWnd,GWL_EXSTYLE
    invoke SetWindowLong,ebx,GWL_EXSTYLE,eax
    invoke GetWindowLong,hWnd,GWL_STYLE
    or eax,WS_CHILD
    invoke SetWindowLong,ebx,GWL_STYLE,eax
    invoke GetWindowRect,hWnd,addr rt
    mov eax,rt.left
    and eax,0ffffh
    mov ecx,rt.top
    shl ecx,16
    or ecx,eax
    mov eax,rt.right
    and eax,0ffffh
    mov edi,rt.bottom
    shl edi,16
    or edi,eax
    invoke SetWindowLong,ebx,GWL_USERDATA,ecx
    invoke SetWindowLong,ebx,DWL_USER,edi
;;    invoke GetWindow,hWnd,GW_OWNER
;;    mov ebx,eax
    mov ebx,mbowner
    invoke GetWindowLong,ebx,GWL_EXSTYLE
    invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
    invoke GetWindowLong,ebx,GWL_STYLE
    and eax,not WS_DISABLED
    invoke SetWindowLong,hWnd,GWL_STYLE,eax
    invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_HIDEWINDOW
    invoke EnumChildWindows,ebx,offset CopyControl,hWnd  ; (instead of dlgitemtemplate reading)
    invoke SendMessage,ebx,DM_GETDEFID,0,0
    mov ecx,eax
    and ecx,0ffffh
    shr eax,16
    .if eax==DC_HASDEFID_M
      invoke SendMessage,hWnd,DM_SETDEFID,ecx,0
    .endif
    invoke SetWindowLong,hWnd,DWL_DLGPROC,offset DlgProc
    mov edi,eax
    invoke SetDlgItemData,hWnd,id+15,edi
    invoke SetDlgItemData,hWnd,id+44,edi
    invoke SetWindowLong,hWnd,GWL_WNDPROC,offset WndProc
    invoke SetDlgItemData,hWnd,id+16,eax ; (offset NewMsgBox)
    mov eax,hookflag
    mov oldmbwndproc,eax
    invoke SetDlgItemData,hWnd,id+43,eax
    .if hhook!=0
      invoke UnhookWindowsHookEx,hhook
      xor eax,eax
      mov hhook,eax
      mov hookflag,eax
    .endif
    invoke SendMessage,hWnd,WM_INITDIALOG,0,ebx
    invoke InvalidateRect,hWnd,0,1
    mov eax,FALSE

  .elseif uMsg==WM_CLOSE || (uMsg==WM_COMMAND && (wParam==2 || wParam==6 || wParam==7))
    invoke OnClose,hWnd
    mov eax,FALSE

  .elseif uMsg==WM_SETCURSOR
    invoke GetCursorPos,addr pt
    invoke DescendantWindowFromPoint,hWnd,pt.x,pt.y,hWnd
    invoke GetWindowLong,eax,GWL_ID
    and eax,0ffffh
    mov ecx,lParam
    shr ecx,16    
    .if eax==id+31 && ecx==WM_RBUTTONUP
      invoke PostMessage,hWnd,WM_APP+id,0,0  ; (Msg box -> Dlg box)
    .elseif eax==id+31 && ecx==WM_MBUTTONUP
      invoke PostMessage,hWnd,WM_APP+id+1,0,0  ; (-> old Msg box)
    .endif
    jmp @f
    
  .elseif uMsg==WM_APP+id
    invoke ProcSwitch,hWnd  ; (Msg box / Dlg box)
    mov eax,FALSE

  .elseif uMsg==WM_APP+id+1
    invoke GetDlgItemData,hWnd,id+31
    .if eax==7
      dec nowned
    .endif
    invoke GetDlgItemData,hWnd,id+43
    mov esi,eax
    invoke EnumChildWindows,hWnd,offset RestoreMsgBox,0
    invoke GetWindow,hWnd,GW_CHILD
    invoke GetWindow,eax,GW_HWNDLAST
    mov ebx,eax
    invoke GetWindowText,ebx,addr buf,127
    invoke SetWindowText,hWnd,addr buf
    invoke GetWindowLong,ebx,GWL_EXSTYLE
    invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
    invoke GetWindowLong,ebx,GWL_STYLE
    and eax,not WS_CHILD
    invoke SetWindowLong,hWnd,GWL_STYLE,eax
    invoke GetWindowLong,ebx,DWL_USER
    mov edi,eax
    invoke GetWindowLong,ebx,GWL_USERDATA
    mov ecx,eax
    and eax,0ffffh
    shr ecx,16
    mov edx,edi
    and edi,0ffffh
    shr edx,16
    sub edi,eax
    sub edx,ecx
    invoke SetWindowPos,hWnd,0,eax,ecx,edi,edx,SWP_NOZORDER OR SWP_FRAMECHANGED OR SWP_SHOWWINDOW
    invoke DestroyWindow,ebx
    invoke SetWindowLong,hWnd,GWL_WNDPROC,esi
    mov eax,FALSE

;  .elseif uMsg==WM_COPY
;    mov eax,FALSE
   
  .elseif uMsg==WM_TIMER
    mov eax,FALSE
    
  .else
@@:
    invoke DefDlgProc,hWnd,uMsg,wParam,lParam
  .endif
  ret
NewMsgBox endp

;#########################################################################################

CBTProc proc uses ebx edi nCode:UINT, wParam:WPARAM, lParam:LPARAM
  
  local buf[128]:BYTE
  
  .if nCode==HCBT_CREATEWND && hookflag==0
    mov ebx,wParam
    invoke GetKeyState,VK_MBUTTON                 ; mouse M-button
    and eax,8000h
    .if eax!=0
      invoke GetWindow,ebx,GW_OWNER
      mov edi,eax
      invoke GetAncestor,ebx,GA_PARENT  ; (also GetWindowLong(GWL_HWNDPARENT)) ; => eax==00010016h = hwnd of top message-only (class "Message") ?? ; (XP-pro-sp2)
      invoke wsprintf,addr buf,offset _hk,edi,eax
      invoke TextOut,hdc,800,toptextout,addr buf,eax
    .endif
    invoke GetWindowLong,ebx,GWL_STYLE
    and eax,not (DS_NOIDLEMSG OR WS_DISABLED)
    invoke SetWindowLong,ebx,GWL_STYLE,eax
    invoke SetWindowLong,ebx,GWL_WNDPROC,offset NewMsgBox
    mov hookflag,eax ; oldmbwndproc
    invoke PostMessage,ebx,WM_APP+WM_CREATE,0,0
    mov eax,FALSE
  .else
    invoke CallNextHookEx,hhook,nCode,wParam,lParam
  .endif
  ret
CBTProc endp

;#########################################################################################

EnThWnd proc hWnd:HWND,lParam:LPARAM
  mov eax,lParam
  inc byte ptr[eax]
  xor eax,eax
  ret
EnThWnd endp

;#########################################################################################

MsgBox proc uses ebx edi hWnd:HWND,hW:HWND

  local buf[128]:BYTE ;,mbp:MSGBOXPARAMS

  xor edi,edi
  invoke GetKeyState,VK_RBUTTON             ; mouse R-button
  and eax,8000h
  .if hW==0
    mov edx,7  ; non-owned
    mov ecx,hWnd
  .else
    mov edx,8  ; owned
    mov ecx,hW
  .endif
  mov mbowner,ecx
  .if hhook==0 && hookflag==0 && eax==0
    invoke SetDlgItemInt,hWnd,id+12,edx,0
    invoke SetWindowsHookEx,WH_CBT,offset CBTProc,0,tid1
    mov hhook,eax
    mov eax,offset _hook
  .else
    .if edx==7
      inc edi
      inc nowned
    .endif
    mov eax,offset _msgb
  .endif
  inc counter
  invoke wsprintf,addr buf,eax,counter
  invoke SetLastError,0

  invoke MessageBox,hW,offset _mbfact,addr buf,MB_TOPMOST or MB_HELP or MB_DEFBUTTON2 or MB_YESNOCANCEL or MB_ICONINFORMATION ; or MB_TASKMODAL

;  invoke MessageBoxEx,hW,offset _mbfact,addr buf,MB_TOPMOST or MB_HELP or MB_DEFBUTTON2 or MB_YESNOCANCEL or MB_ICONINFORMATION,0 ; (wLanguageId)

;  mov mbp.cbSize,sizeof MSGBOXPARAMS
;  mov mbp.hwndOwner,hW
;  mov mbp.hInstance,0
;  mov mbp.lpszText,offset _mbfact
;  lea eax,buf
;  mov mbp.lpszCaption,eax
;  mov mbp.dwStyle,MB_TOPMOST or MB_HELP or MB_DEFBUTTON2 or MB_YESNOCANCEL or MB_ICONINFORMATION
;  mov mbp.lpszIcon,0
;  mov mbp.dwContextHelpId,0
;  mov mbp.lpfnMsgBoxCallback,0
;  mov mbp.dwLanguageId,LANG_NEUTRAL
;  invoke MessageBoxIndirect,addr mbp

;  invoke GetModuleHandle,offset _user32
;  invoke GetProcAddress,eax,offset _messageboxtimeouta
;  push 3000  ; (dwMilliseconds)
;  push 0     ; (wLanguageId)
;  push MB_TOPMOST or MB_HELP or MB_DEFBUTTON2 or MB_YESNOCANCEL or MB_ICONINFORMATION ; or MB_TASKMODAL
;  lea ecx,buf
;  push ecx
;  push offset _mbfact
;  push hW
;  call eax   ; (MessageBoxTimeout, undocumented, WinOS>=XP)

  invoke GetLastError
  mov ebx,eax
  
  .if hhook!=0                        ; for case "SetClassLong(GCL_CBWNDEXTRA,0)"
    invoke UnhookWindowsHookEx,hhook
    xor eax,eax
    mov hhook,eax
    mov hookflag,eax
  .endif
  
  mov byte ptr[buf],0
  invoke EnumThreadWindows,tid1,addr EnThWnd,addr buf ; (IsThreadWindow)
  .if byte ptr[buf]==0
    invoke PostQuitMessage,0
  .endif
  invoke SetDlgItemInt,hWnd,id+25,ebx,0
  .if edi!=0
    dec nowned
  .endif  
  ret
MsgBox endp

;#########################################################################################

OnMouseWheel proc uses ebx edi esi hWnd:HWND,wParam:WPARAM,lParam:LPARAM

  local buf[8]:DWORD
  
  mov eax,lParam
  mov ecx,eax
  and eax,0ffffh
  shr ecx,16
  invoke DescendantWindowFromPoint,0,eax,ecx,hWnd
  mov edi,eax
  invoke GetWindowLong,edi,GWL_ID
  mov esi,eax
  invoke GetAncestor,edi,GA_ROOT
  mov ebx,wParam
  .if bx==MK_SHIFT                                                         ; SHIFT key -> send DM_SETDEFID
    invoke SendMessageTimeout,eax,DM_SETDEFID,esi,0,SMTO_ABORTIFHUNG,300,0
  .elseif bx==MK_CONTROL                                                   ; CTRL key -> post WM_TIMER => test on Message Box (close?)
    invoke PostMessage,eax,WM_TIMER,0,0
  .else
    xor ecx,ecx
    .if ebx<=7FFFFFFFh
      dec ecx
    .else
      inc ecx
    .endif
    mov ebx,ecx
    .if esi==id+25                                                         ; error codes
      invoke GetDlgItemInt,hWnd,id+25,0,0
      .if eax!=0 || ebx==1
        add eax,ebx
      .endif
      invoke SetDlgItemInt,hWnd,id+25,eax,0
      invoke SetDlgItemData,hWnd,id+25,5
    .elseif esi==id+5                                                      ; hwnd via ...
      invoke SetDlgItemData,hWnd,id+25,7
      invoke GetDlgItemData,hWnd,id+5
      add eax,ebx
      .if eax>5
        mov eax,5
      .elseif eax<0
        xor eax,eax
      .endif
      mov edi,eax
      invoke SetDlgItemData,hWnd,id+5,eax
      invoke wsprintf,addr buf,offset _hwnd,edi
      invoke SetDlgItemText,hWnd,id+5,addr buf
    .else                                                                 ; Details switch
      invoke GetDlgItemData,hWnd,id+25
      add eax,ebx
      and eax,7
      invoke SetWindowLong,edx,GWL_USERDATA,eax
    .endif
  .endif
  ret
OnMouseWheel endp

;#########################################################################################

OnCommand proc uses ebx edi esi hWnd:HWND,wParam,lParam

  local buf[128]:BYTE, buf2[128]:BYTE

  invoke GetDlgItemData,hWnd,id+3
  mov esi,eax
  invoke IsDlgButtonChecked,hWnd,id+42
  push eax
  invoke IsDlgButtonChecked,hWnd,id+2
  mov ebx,eax
  invoke IsDlgButtonChecked,hWnd,id+1
  pop edx
  mov edi,wParam
  mov ecx,edi
  and edi,0ffffh
  shr ecx,16

  .if edi==id+1
    .if eax==0
      invoke KillTimer,hWnd,id
      invoke CheckDlgButton,hWnd,id+1,BST_UNCHECKED
    .else
      invoke SetTimer,hWnd,id,100,0
      invoke CheckDlgButton,hWnd,id+1,BST_CHECKED
    .endif

  .elseif edi==id+7
    invoke ExtraSub,hWnd,esi,id+10,1

  .elseif edi==id+45
    .if ebx==0
      mov esi,hWnd
    .endif
    invoke GetSystemMenu,esi,FALSE
    invoke GetSystemMenu,esi,TRUE

  .elseif edi==id+3 && eax==0 && (ecx==EN_CHANGE || ecx==EN_UPDATE)
    invoke SendDlgItemMessage,hWnd,edi,WM_GETTEXT,9,addr buf
    .if eax>=8
      mov bl,byte ptr [buf+8]
      mov byte ptr [buf+8],0
      invoke htodw,addr buf
      mov byte ptr [buf+8],bl
      mov ebx,eax
      invoke IsWindow,ebx
      .if eax!=0
        invoke SetDlgItemData,hWnd,id+3,ebx
        invoke CheckDlgButton,hWnd,id+2,BST_CHECKED
        invoke ShowInfo,hWnd,ebx
      .else
@beep:
        invoke MessageBeep,0
      .endif
    .endif

  .elseif (edi==id+37 ||edi==id+38) && eax==0 && (ecx==EN_CHANGE || ecx==EN_UPDATE)
    push edx
    invoke SendDlgItemMessage,hWnd,edi,WM_GETTEXT,9,addr buf
    pop edx
    .if eax>=8 && edx==0 && ebx!=0
      mov bl,byte ptr [buf+8]
      mov byte ptr [buf+8],0
      invoke htodw,addr buf
      mov byte ptr [buf+8],bl
      mov ebx,eax
      .if edi==id+37
        mov ecx,GWL_STYLE
      .else
        mov ecx,GWL_EXSTYLE
      .endif
      invoke SetWindowLong,esi,ecx,ebx
      invoke SetWindowPos,esi,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
    .elseif eax>=8 && edx!=0
      mov bl,byte ptr [buf+8]
      mov byte ptr [buf+8],0
      invoke htodw,addr buf
      mov byte ptr [buf+8],bl
      mov ebx,eax    
      mov eax,lptmpl
      .if edi==id+37
        mov dword ptr[eax+12],ebx  ; ws
      .else
        mov dword ptr[eax+8],ebx  ; ws_ex
      .endif
    .endif
    invoke ShowInfo,hWnd,esi

  .elseif edi==id+42 && edx!=0 && ecx==BN_CLICKED
    invoke ReadTemplate,addr buf
    invoke SetDlgItemText,hWnd,id+12,addr buf

  .elseif edi==id+26
    .if ebx==0
      mov esi,hWnd
    .endif
    invoke SendMessage,esi,DM_REPOSITION,0,0  ; (test "Is Window Dialog?")

  .elseif edi>=id+21 && edi<=id+24
    invoke IsDlgButtonChecked,hWnd,id+29
    xor ecx,ecx    
    .if eax!=0
      inc ecx
      .if ebx!=0
        mov ebx,esi
      .else
        mov ebx,hWnd
      .endif
    .else    
      xor ebx,ebx
    .endif
    
    .if edi==id+23
      add ecx,1
      invoke SetDlgItemInt,hWnd,id+12,ecx,0
      invoke SetLastError,0      
      invoke DialogBoxParam,hinst,id,ebx,offset DlgProc,hWnd
      jmp @f

    .elseif edi==id+22
      add ecx,3
      invoke SetDlgItemInt,hWnd,id+12,ecx,0
      invoke SetLastError,0
      invoke CreateDialogParam,hinst,id,ebx,offset DlgProc,hWnd
@@:
      invoke GetLastError
      invoke SetDlgItemInt,hWnd,id+25,eax,0
      
    .elseif edi==id+21
      add ecx,5
      invoke SetDlgItemInt,hWnd,id+12,ecx,0
      invoke CreateDlgWindow,ebx,hWnd

    .elseif edi==id+24
      invoke MsgBox,hWnd,ebx

    .endif

  .elseif edi==id+32 || edi==id+33
    .if eax!=0
      jmp @beep
    .else
      invoke GetDlgItemText,hWnd,id+12,addr buf,127
      mov esi,eax
      .if edi==id+32
        invoke GetDlgItemInt,hWnd,id+9,0,0
        push eax
        invoke GetDlgItemInt,hWnd,id+10,0,0
        push eax
        invoke GetDlgItemText,hWnd,id+13,addr buf2,9
        invoke htodw,addr buf2
        pop ecx
        pop edx
        invoke RegisterWndClass,hinst,offset WndProc,addr buf,edx,ecx,eax
        push ecx
        invoke SetDlgItemInt,hWnd,id+25,edx,0
        pop ecx
        .if ecx==0
          jmp @beep
        .else
          .if esi==6
            invoke SendDlgItemMessage,hWnd,id+12,CB_ADDSTRING,0,addr buf
            jmp @f
          .endif
        .endif
      .else
        invoke SetLastError,0
        invoke UnregisterClass,addr buf,hinst
        push eax
        invoke GetLastError
        invoke SetDlgItemInt,hWnd,id+25,eax,0
        invoke ClassInfo,hWnd,hinst
        pop eax
        .if eax==0
          jmp @beep
        .else
          invoke SendDlgItemMessage,hWnd,id+12,CB_FINDSTRING,-1,addr buf
          .if eax!=CB_ERR
            invoke SendDlgItemMessage,hWnd,id+12,CB_DELETESTRING,eax,0
@@:
            invoke EnumThreadWindows,tid1,addr CopyComboContent,hWnd
          .endif
        .endif
      .endif
    .endif

  .elseif edi==id+27 && ebx!=0
    invoke IsDlgButtonChecked,hWnd,edi
    mov ebx,eax
    .if eax!=0
      mov eax,DS_NOIDLEMSG
    .endif
    mov noIdle,eax
    invoke StyleSwitch,hWnd,GWL_STYLE,DS_NOIDLEMSG,ebx
    
  .elseif edi==id+28 && ebx!=0
    invoke IsDlgButtonChecked,hWnd,edi
    invoke StyleSwitch,hWnd,GWL_EXSTYLE,WS_EX_CONTROLPARENT,eax      
  .elseif edi==id+30 && ebx!=0
    invoke IsDlgButtonChecked,hWnd,edi
    .if eax!=0
      mov ebx,FALSE
    .else
      mov ebx,TRUE
    .endif
    invoke GetDlgItemData,hWnd,id+3
    invoke EnableWindow,eax,ebx
  .endif
  ret
OnCommand endp

;#########################################################################################

OnSetCursor proc uses ebx edi esi hWnd:HWND,wParam:WPARAM,lParam:LPARAM

  local pt:POINT, retval:DWORD, buf[128]:BYTE, var:DWORD
  
  invoke GetCursorPos,addr pt
  mov esi,wParam
  .if esi==hWnd
    invoke DescendantWindowFromPoint,esi,pt.x,pt.y,hWnd
    mov esi,eax
  .endif
  xor edi,edi
  .if esi!=hWnd
;;    invoke GetDlgCtrlID,esi
;;    invoke GetMenu,esi  
    invoke GetWindowLong,esi,GWL_ID
    mov edi,eax      
    and edi,0ffffh
  .endif
  invoke GetDlgItemData,hWnd,id+3
  mov ebx,eax
  invoke IsDlgButtonChecked,hWnd,id+1
  mov var,eax
  invoke IsDlgButtonChecked,hWnd,id+2
  mov edx,lParam
  mov ecx,edx
  and ecx,0ffffh
  shr edx,16

  .if ((edi==id+1 || edi==id+2 || edi==id+17 || edi==id+21 || edi==id+22 || edi==id+23 || edi==id+26 || edi==id+29 || edi==id+42 || edi==id+45) && edx==WM_RBUTTONUP) || (edi==id+24 && (edx==WM_RBUTTONUP || edx==WM_MBUTTONUP))
    jmp @f
  .elseif (edi==id+27 || edi==id+28 || edi==id+30) && edx==WM_RBUTTONUP
    .if eax!=0
@@:
      invoke SendMessage,esi,BM_CLICK,0,0
    .else
@beep:
      invoke MessageBeep,0
    .endif

  .elseif edi==id+20 && edx==WM_RBUTTONUP
;;   xor smflag,1
    invoke GetDlgItemData,hWnd,id+8
    mov edi,edx
    xor eax,1
    invoke SetWindowLong,edi,GWL_USERDATA,eax

  .elseif edi==id+31 && (edx==WM_RBUTTONUP || edx==WM_MBUTTONUP)
    mov esi,edx
    invoke GetDlgItemData,hWnd,id+31
    .if (eax==7 || eax==8) && esi==WM_RBUTTONUP
      invoke PostMessage,hWnd,WM_APP+id,0,0  ; (Dlg box -> Msg box)
    .else
      jmp @beep
    .endif

  .elseif edi==id+14 && edx==WM_RBUTTONUP
    push eax
    invoke IsDlgButtonChecked,hWnd,id+17
    pop ecx
    .if ecx==0 || eax==0
      jmp @beep
    .else
      invoke SendMessageTimeout,ebx,DM_GETDEFID,0,0,SMTO_ABORTIFHUNG,300,addr retval
      mov eax,retval
      mov edx,eax
      and eax,0ffffh
      shr edx,16
      xor eax,1
      .if edx!=DC_HASDEFID_M
        xor eax,eax
        inc eax
      .endif
      invoke SendMessageTimeout,ebx,DM_SETDEFID,eax,0,SMTO_ABORTIFHUNG,300,0
    .endif

  .elseif edi==id+16 && edx==WM_RBUTTONUP
    mov edi,GWL_USERDATA
    jmp @f
  .elseif edi==id+15 && edx==WM_RBUTTONUP
    mov edi,GWL_ID
@@:
    .if eax==0
      jmp @beep
    .else
      invoke GetWindowLong,ebx,edi
      xor eax,1
      invoke SetWindowLong,ebx,edi,eax
      invoke ShowInfo,hWnd,ebx
      invoke InvalidateRect,ebx,0,1
      invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
    .endif

  .elseif edi==id+40 && edx==WM_RBUTTONUP
    .if eax==0 || var!=0
      jmp @beep
    .else
      invoke GetDlgItemText,hWnd,id+37,addr buf,127 ; ws_
      invoke htodw,addr buf
      invoke SetWindowLong,ebx,GWL_STYLE,eax
      invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
    .endif

  .elseif edi==id+41 && edx==WM_RBUTTONUP
    .if eax==0 || var!=0
      jmp @beep
    .else
      invoke GetDlgItemText,hWnd,id+38,addr buf,127 ; ws_ex_
      invoke htodw,addr buf
      mov esi,eax
      invoke SetWindowLong,ebx,GWL_EXSTYLE,eax
      and esi,WS_EX_TOPMOST
      .if esi==0
        mov ecx,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
      .else
        mov esi,HWND_TOPMOST
        mov ecx,SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
      .endif
      invoke SetWindowPos,ebx,esi,0,0,0,0,ecx
    .endif

  .elseif edi==id+44 && edx==WM_RBUTTONUP
    .if eax==0 || var!=0
      jmp @beep
    .else
      invoke GetDlgItemText,hWnd,id+13,addr buf,127 ; cs_
      invoke htodw,addr buf
      invoke SetClassLong,ebx,GCL_STYLE,eax
      invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
    .endif

  .elseif edi==id+6 && edx==WM_RBUTTONUP
    mov edi,id+9
    mov esi,GCL_CBCLSEXTRA
    jmp @f
  .elseif edi==id+7 && edx==WM_RBUTTONUP
    mov edi,id+10
    mov esi,GCL_CBWNDEXTRA
@@:  
    .if eax==0 || var!=0
      jmp @beep
    .else
      invoke GetDlgItemInt,hWnd,edi,0,0
      invoke SetClassLong,ebx,esi,eax
      invoke ExtraSub,hWnd,ebx,edi,1
    .endif

  .elseif edi==id+35 && edx==WM_RBUTTONDOWN
    xor edx,edx  ; =0
    jmp @f
  .elseif edi==id+35 && edx==WM_RBUTTONUP
@@:
    mov ebx,edx  ; !=0
    invoke KillTimer,hWnd,id
    invoke CheckDlgButton,hWnd,id+1,BST_UNCHECKED
    invoke ClassInfo,hWnd,ebx
    invoke Details,hWnd,0

  .elseif esi==hWnd && edx==WM_MBUTTONUP
    invoke GetDlgItemData,hWnd,id+19
    mov ebx,edx
    .if eax==0 && msgflag==0
      inc eax
      jmp @f
    .elseif eax!=0 && msgflag!=0
      xor eax,eax
@@:
      mov msgflag,eax
      invoke SetWindowLong,ebx,GWL_USERDATA,eax
      invoke InvalidateRect,0,0,1          
    .endif

  .endif
  ret
OnSetCursor endp

;#########################################################################################

OnInitDialog proc uses ebx edi esi hWnd:HWND,lParam:LPARAM

  local rt:RECT, buf[128]:BYTE

  mov ebx,noIdle
  invoke GetWindowLong,hWnd,GWL_STYLE
  or eax,ebx
  invoke SetWindowLong,hWnd,GWL_STYLE,eax
  invoke OrWS,hWnd,GWL_STYLE,WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX  
  .if ebx!=0
    invoke CheckDlgButton,hWnd,id+27,BST_CHECKED
  .endif 
  invoke SetDlgItemInt,hWnd,id+9,0,0
  mov edi,id+9
  .while edi<=id+12
    invoke GetDlgItem,hWnd,edi
    mov ebx,eax
    invoke SetWindowLong,ebx,GWL_WNDPROC,offset HTTransparentControl
    invoke SetWindowLong,ebx,GWL_USERDATA,eax
    invoke GetWindow,ebx,GW_CHILD
    mov ebx,eax
    invoke SetWindowLong,ebx,GWL_WNDPROC,offset NewCombol
    invoke SetWindowLong,ebx,GWL_USERDATA,eax
    inc edi
  .endw
  invoke GetDlgItem,hWnd,id+20
  mov ebx,eax
  invoke SetWindowLong,ebx,GWL_WNDPROC,offset MultilineEdit
  invoke SetWindowLong,ebx,GWL_USERDATA,eax
  mov ebx,lParam
  mov esi,BST_CHECKED
  .if ebx>=0 && ebx<=8  ; (init: lParam=3)
    mov edi,ebx
    invoke SendDlgItemMessage,hWnd,id+12,CB_ADDSTRING,0,offset _dlg
    invoke SendDlgItemMessage,hWnd,id+12,CB_ADDSTRING,0,offset _wnd
  .else  ; ebx<0 || ebx>8
    invoke GetDlgItemInt,ebx,id+12,0,0
    mov edi,eax
    invoke CopyComboContent,hWnd,ebx
    invoke GetClassName,hWnd,addr buf,8
    invoke SetDlgItemText,ebx,id+12,addr buf
    invoke IsDlgButtonChecked,ebx,id+17
    .if eax==0
      mov esi,BST_UNCHECKED
    .endif
  .endif
  invoke CheckDlgButton,hWnd,id+17,esi
  invoke CheckDlgButton,hWnd,id+1,BST_CHECKED
  invoke SetDlgItemData,hWnd,id+31,edi
  invoke SetDlgItemText,hWnd,id+12,offset _ver
  invoke GetDlgItem,hWnd,id+12
  invoke GetDlgItem,eax,1001
  invoke SendMessage,eax,EM_SETSEL,0,40000h
  .if edi==1 || edi==2
    mov eax,offset _dlgbox
  .elseif edi==3 || edi==4
    mov eax,offset _createdlg
  .elseif edi==5 || edi==6
    mov eax,offset _createwnd
  .elseif edi==7 || edi==8
    mov eax,offset _msgbox
  .else
    mov eax,offset _z
  .endif
  inc counter
  invoke wsprintf,addr buf,offset _app,eax,counter
  invoke SendMessage,hWnd,WM_SETTEXT,0,addr buf
  .if edi==1 || edi==3 || edi==5 || edi==7
    inc nowned
  .endif
  .if edi!=7 && edi!=8
    invoke SetWindowLong,hWnd,GWL_WNDPROC,offset WndProc
    .if eax!=offset WndProc
      invoke SetDlgItemData,hWnd,id+43,eax
    .endif
  .endif
  .if cpos==0
    invoke GetWindowRect,hWnd,addr rt
    mov eax,rt.left
    and eax,0ffffh
    mov ecx,rt.top
    shl ecx,16
    or eax,ecx
    mov cpos,eax
  .elseif cpos!=0 && (edi==5 || edi==6 || edi==7 || edi==8)
    invoke GetWindowRect,ebx,addr rt
    mov eax,rt.left
    sub rt.right,eax
    mov eax,rt.top
    sub rt.bottom,eax
    mov eax,cpos
    mov ecx,eax
    and eax,0ffffh
    shr ecx,16
    invoke SetWindowPos,hWnd,HWND_TOPMOST,eax,ecx,rt.right,rt.bottom,SWP_FRAMECHANGED
  .endif
  invoke wsprintf,addr buf,offset _lX,hWnd
  invoke SetDlgItemText,hWnd,id+31,addr buf
;  invoke SendDlgItemMessage,hWnd,id+12,CB_LIMITTEXT,6,0
  invoke SetDlgItemData,hWnd,id+5,1
  push id+3
  push id+37
  push id+38
  xor ebx,ebx
  .while ebx<3
    pop eax
    invoke SendDlgItemMessage,hWnd,eax,EM_LIMITTEXT,8,0
    inc ebx
  .endw
  invoke SetTimer,hWnd,id,100,0
  ret
OnInitDialog endp

;#########################################################################################

DlgProc proc uses ebx edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local buf[128]:BYTE
  
  .if msgflag!=0
    invoke GetDlgItemData,hWnd,id+19  ; (hWnd msgflag)
    .if eax!=0
      invoke GetDlgItemData,hWnd,id+2  ; (DlgMsgCount)
      mov ebx,edx
      inc eax
      invoke SetWindowLong,ebx,GWL_USERDATA,eax
      invoke wsprintf,addr buf,offset _msgdlg,eax
      invoke TextOut,hdc,300,toptextout,addr buf,eax
    .endif
  .endif

  mov eax,uMsg
  .if eax==WM_INITDIALOG
    invoke OnInitDialog,hWnd,lParam
    mov eax,TRUE ; FALSE ; 

  .elseif eax==WM_CLOSE
    invoke OnClose,hWnd
    mov eax,TRUE

  .elseif eax==WM_TIMER
    invoke OnTimer,hWnd    
    mov eax,TRUE

  .elseif eax==WM_NCHITTEST
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam  ; (not DefDlgProc !)
    .if eax==HTCLIENT || eax==HTBORDER
      mov eax,HTCAPTION
    .endif
    invoke SetWindowLong,hWnd,DWL_MSGRESULT,eax
    mov eax,TRUE

  .elseif eax==WM_SETCURSOR
    invoke OnSetCursor,hWnd,wParam,lParam
    mov eax,FALSE

  .elseif eax==WM_COMMAND
    invoke OnCommand,hWnd,wParam,lParam
    mov eax,TRUE

;  .elseif eax==WM_CTLCOLORSTATIC
;    invoke GetWindowLong,lParam,GWL_ID
;    mov edi,eax
;    .if edi==id+31 || edi==id+46
;      invoke SetBkMode,wParam,TRANSPARENT
;      invoke SetTextColor,wParam,Red
;      invoke GetStockObject,NULL_BRUSH
;    .else
;      mov eax,FALSE
;    .endif

;  .elseif eax==WM_CTLCOLORSTATIC || eax==WM_CTLCOLORDLG  ; (retval != BOOL)
;    invoke GetStockObject,WHITE_BRUSH

  .elseif eax==WM_ENTERIDLE
    invoke SetDlgItemData,hWnd,id+30,lParam
    invoke GetDlgItemData,hWnd,id+27
    mov edx,wParam
    mov ah,dl
    inc al
    mov ebx,eax
    invoke SetDlgItemData,hWnd,id+27,ebx
    and ebx,0ffh
    invoke wsprintf,addr buf,offset _noidle,wParam,ebx
    invoke SetDlgItemText,hWnd,id+27,addr buf
    mov eax,FALSE    

  .elseif eax==WM_MOUSEWHEEL
    invoke OnMouseWheel,hWnd,wParam,lParam
    mov eax,FALSE

  .elseif uMsg==WM_APP+id
    invoke GetDlgItemData,hWnd,id+31
    .if eax==7 || eax==8
      invoke ProcSwitch,hWnd  ; (Msg box / Dlg box)
    .endif
    mov eax,TRUE

	.else
    mov eax,FALSE
  .endif
  ret
DlgProc endp

;#########################################################################################

WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local buf[16]:BYTE

  .if msgflag!=0
    invoke GetDlgItemData,hWnd,id+19  ; (hWnd msgflag)
    .if eax!=0
      invoke GetDlgItemData,hWnd,id+1  ; (WndMsgCount)
      mov ebx,edx
      inc eax
      invoke SetWindowLong,ebx,GWL_USERDATA,eax
      invoke wsprintf,addr buf,offset _msgwnd,eax
      invoke TextOut,hdc,150,toptextout,addr buf,eax
    .endif
  .endif

  mov eax,uMsg
  .if eax==WM_CREATE
;    invoke OrWS,hWnd,WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX
    xor eax,eax

  .elseif eax==WM_CTLCOLORSTATIC
    invoke GetWindowLong,lParam,GWL_ID
    .if eax==id+46 || eax==id+31
      invoke SetBkMode,wParam,TRANSPARENT
      invoke SetTextColor,wParam,Red
      invoke GetStockObject,NULL_BRUSH
    .else
      jmp @f
    .endif
  .else
@@:
    invoke DefDlgProc,hWnd,uMsg,wParam,lParam
;    .if uMsg==WM_NCHITTEST && (eax==HTCLIENT || eax==HTBORDER)
;      mov eax,HTCAPTION
;    .endif
  .endif
  ret
WndProc endp

;#########################################################################################

ActiveDialogMessageLoop proc uses ebx

  local msg:MSG, buf[64]:BYTE
; ebx: LoopMsgCount

  xor ebx,ebx
  .while TRUE
    .if msgflag!=0
      inc ebx
      invoke wsprintf,addr buf,offset _msgloop,ebx
      invoke TextOut,hdc,10,toptextout,addr buf,eax
    .endif
    invoke GetMessage,addr msg,0,0,0
    .break .if !eax
    invoke GetActiveWindow
    mov ecx,eax
    .if ecx!=0
      invoke IsDialogMessage,ecx,addr msg
      .continue .if eax
    .endif
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
  .endw
  mov	eax,msg.wParam
  ret
ActiveDialogMessageLoop endp

;#########################################################################################

ThreadProc proc uses ebx lParam:LPARAM

  local buf[64]:BYTE
  
  xor ebx,ebx
@@:
  inc ebx
  invoke Sleep,100
  .if msgflag!=0
    invoke CountUserGdiObjects
    invoke wsprintf,addr buf,offset _ugo,eax,edx,lParam,tid2,ebx
    invoke TextOut,hdc,450,toptextout,addr buf,eax
  .endif
  jmp @b
  ret
ThreadProc endp

;#########################################################################################

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke FindResource,0,id,RT_DIALOG
  invoke LoadResource,0,eax
  invoke LockResource,eax  ; (? eax = LockResource(eax))
  mov lptmpl,eax
  invoke GetDC,0
  mov hdc,eax
  invoke CreateFontIndirect,offset lf
  mov hfont,eax
  invoke GetCurrentThreadId
  mov tid1,eax
  invoke CreateThread,0,0,offset ThreadProc,eax,0,offset tid2
  invoke CloseHandle,eax
;  invoke CreateDialogIndirectParam,hinst,lptmpl,0,offset DlgProc,3
  invoke CreateDialogParam,hinst,id,0,offset DlgProc,3
  invoke GetClassLong,eax,GCL_STYLE
  invoke RegisterWndClass,hinst,offset WndProc,offset _wnd,20,36,eax
  invoke ActiveDialogMessageLoop
  push eax
  invoke DeleteObject,hfont
  invoke ReleaseDC,0,hdc
  invoke InvalidateRect,0,0,1
  call ExitProcess
  invoke InitCommonControls
end start

;#########################################################################################

;EnThWin proc hWnd:HWND,lParam:LPARAM
;
;  invoke SendMessage,hWnd,WM_TIMER,lParam,0
;;  invoke PostMessage,hWnd,WM_TIMER,lParam,0
;  mov eax,TRUE
;  ret
;EnThWin endp

;#########################################################################################

;ThreadProc proc lParam:LPARAM
;@@:
;  invoke Sleep,100
;  invoke EnumThreadWindows,lParam,offset EnThWin,lParam
;  jmp @b
;  ret
;ThreadProc endp

;#########################################################################################

;ThreadProc proc uses ebx edi lParam:LPARAM
;
;  local msg:MSG, buf[64]:BYTE
;
;  xor edi,edi
;  invoke SetTimer,0,0,100,0
;  mov ebx,eax
;  .while TRUE
;    invoke GetMessage,addr msg,0,0,0
;    .break .if (!eax)    
;    .if msg.message==WM_TIMER && eax!=-1
;      invoke EnumThreadWindows,lParam,offset EnThWin,ebx
;    .endif
;    invoke TranslateMessage,addr msg
;    invoke DispatchMessage,addr msg
;  .endw
;  invoke KillTimer,0,ebx
;  invoke ExitThread,0
;  ret
;ThreadProc endp

;#########################################################################################

;DialogMessageLoop proc hWnd:HWND
;
;  local msg:MSG
;
;  .while TRUE
;    invoke GetMessage,addr msg,0,0,0
;    .break .if (!eax)
;    invoke IsDialogMessage,hWnd,addr msg
;    .if eax==FALSE
;      invoke TranslateMessage,addr msg
;      invoke DispatchMessage,addr msg
;    .endif
;  .endw
;  mov	eax,msg.wParam
;  ret
;DialogMessageLoop endp

;#########################################################################################
